/***********************************************************************
f77-callable TERMCAP query functions:

	character*80   s
	integer       scrcol, scrlin, n, ncols, nlines
	n = scrclr(s)
	write (*,'(A)') s(1:n)
	ncols = scrcol()
	nlines = scrlin()

[30-Sep-85]
***********************************************************************/

#define MAXBUF 1024         /* fixed buffer for termcap entry */


#ifdef _IBMR2
#define scrclr_ scrclr
#define scrcol_ scrcol
#define scrlin_ scrlin
#endif

char* getenv();
char* tgetstr();
int   tgetent();
int   tgetnum();

int
scrclr_(str)                /* return screen clear string in str, and */
char  *str;                 /* its length as function value */
{
    char bp[MAXBUF];
    char *p;
    int n;

    p = str;
    *str = '\0';
    if (tgetent(bp,getenv("TERM")) == 1)
	(void) tgetstr("cl",&p);
    for (n = 0; str[n]; ++n)
	;
    return (n);
}

int
scrcol_()                                /* return screen width */
{
    char bp[MAXBUF];

    if (tgetent(bp,getenv("TERM")) == 1)
	return(tgetnum("co"));
    else
	return(-1);
}

int
scrlin_()                                /* return screen lines (page size) */
{
    char bp[MAXBUF];

    if (tgetent(bp,getenv("TERM")) == 1)
	return(tgetnum("li"));
    else
	return(-1);
}
