      SUBROUTINE  FNDSTR (TEXT,CC1,CC2,CCL,CCR,QUOTED,ERROR)
C     (Find String)
C     Search the  packed  characters  in  TEXT(*),  beginning  at
C     position CC1  and  continuing up  to  position CC2,  for  a
C     quoted string  or  a Hollerith  string.   On return,  if  a
C     string is found,  CCL and  CCR point to  the left-most  and
C     right-most characters of the  string, and QUOTED is  .TRUE.
C     if the string was quoted, and .FALSE. if it was a Hollerith
C     string (nnH.....).  Error is set .TRUE. if unmatched quotes
C     are found, or if  the end of the  string is reached  before
C     the Hollerith count is exhausted.   If no string is  found,
C     then CCL=CCR=0.
C     (16-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      INTEGER             DECVAL
      LOGICAL             DECDIG,      LETTER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                ACHAR,       BLANK,       BOS,         CCH
C     SETS                CCL,         CCNOW,       CCR,         COUNT
C     SETS                DIGIT,       EOS,         ERROR,       FOUND
C     SETS                NUL,         POWER,       QUOTED
C
      INTEGER             ACHAR,       CC1,         CC2,         CCH
      INTEGER             CCL,         CCNOW,       CCR,         COUNT
      INTEGER             IARG,        NUL,         POWER,       TEXT(1)
      LOGICAL             BLANK,       BOS,         DIGIT,       EOS
      LOGICAL             ERROR,       FOUND,       QUOTED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C
      DATA                NUL       / -1 /
C
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a decimal digit.
C
      DECDIG(IARG) = (ZERORZ .LE. IARG) .AND. (IARG .LE. NINERZ)
C
C     INTEGER statement function returning integer value of a
C     character which is known to represent a digit.
C
      DECVAL(IARG) = IARG - ZERORZ
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a letter.
C
      LETTER(IARG) = (ARZ .LE. IARG) .AND. (IARG .LE. ZRZ)
C
C     EOS = "End of String", BOS = "beginning of String"
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 ASSIGN 20002 TO NPR002
      GO TO 30002
20002 CONTINUE
20003 IF (.NOT.(.NOT.(EOS .OR. FOUND .OR. ERROR))) GO TO 20004
      IF (.NOT.(ACHAR .EQ. QUOTRZ)) GO TO 20005
      ASSIGN 20008 TO NPR003
      GO TO 30003
20008 GO TO 20006
20005 IF (.NOT.(ACHAR .EQ. HRZ)) GO TO 10001
      ASSIGN 20009 TO NPR004
      GO TO 30004
20009 CONTINUE
10001 CONTINUE
20006 CONTINUE
20007 ASSIGN 20010 TO NPR002
      GO TO 30002
20010 GO TO 20003
C
20004 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Classify Character)
30005 BLANK = (ACHAR .EQ. BLNKRZ)
      DIGIT = DECDIG(ACHAR)
      GO TO NPR005, (20012,20019)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Determine Preceding Hollerith Count)
30006 COUNT = 0
      POWER = 1
      ASSIGN 20011 TO NPR007
      GO TO 30007
20011 ASSIGN 20012 TO NPR005
      GO TO 30005
20012 CONTINUE
20013 IF (.NOT.((BLANK .OR. DIGIT) .AND. .NOT.BOS)) GO TO 20014
      IF (.NOT.(DIGIT)) GO TO 20015
      CCL = CCNOW
      COUNT = COUNT + DECVAL(ACHAR)*POWER
      POWER = POWER*10
20015 CONTINUE
20016 ASSIGN 20018 TO NPR007
      GO TO 30007
20018 ASSIGN 20019 TO NPR005
      GO TO 30005
20019 GO TO 20013
20014 IF (LETTER(ACHAR) .AND. .NOT.BOS) COUNT = 0
      GO TO 20032
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Find Matching Quote)
30003 CCL = CCNOW
      ASSIGN 20020 TO NPR002
      GO TO 30002
20020 CONTINUE
20021 IF (.NOT.(.NOT.(EOS .OR. FOUND .OR. ERROR))) GO TO 20022
      IF (.NOT.(ACHAR .EQ. QUOTRZ)) GO TO 20023
      CCR = CCNOW
      ASSIGN 20026 TO NPR002
      GO TO 30002
20026 FOUND = (ACHAR .NE. QUOTRZ)
      IF (.NOT.(FOUND)) GO TO 20027
      ASSIGN 20027 TO NPR007
      GO TO 30007
20027 CONTINUE
20023 ASSIGN 20028 TO NPR002
      GO TO 30002
20028 GO TO 20021
20022 ERROR = .NOT.FOUND
      IF (.NOT.(ERROR)) GO TO 20029
      QUOTED = .FALSE.
      CCL = 0
      CCR = 0
      GO TO 20030
20029 QUOTED = .TRUE.
20030 GO TO 20008
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Find Possible Hollerith String)
30004 CCH = CCNOW
      ASSIGN 20032 TO NPR006
      GO TO 30006
20032 IF (.NOT.(COUNT .GT. 0)) GO TO 20033
      QUOTED = .FALSE.
      CCR = CCH + COUNT
      FOUND = .TRUE.
      ERROR = ERROR .OR. (CCR .GT. CC2)
      GO TO 20034
20033 CCL = 0
      CCR = 0
      FOUND = .FALSE.
20034 IF (.NOT.(ERROR)) GO TO 20036
      FOUND = .FALSE.
      CCL = 0
      CCR = 0
20036 CCNOW = CCH
      GO TO 20009
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Get Last Character From Text String)
30007 CCNOW = CCNOW - 1
      IF (.NOT.(CCNOW .GE. CC1)) GO TO 20039
      BOS = .FALSE.
      ACHAR = CHGET3(TEXT,CCNOW)
      GO TO 20040
20039 BOS = .TRUE.
      ACHAR = NUL
20040 GO TO NPR007, (20011,20018,20027)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Get Next Character From Text String)
30002 CCNOW = CCNOW + 1
      IF (.NOT.(CCNOW .LE. CC2)) GO TO 20042
      EOS = .FALSE.
      ACHAR = CHGET3(TEXT,CCNOW)
      GO TO 20043
20042 EOS = .TRUE.
      ACHAR = NUL
20043 GO TO NPR002, (20002,20010,20020,20026,20028)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize Search)
30001 CCNOW = CC1 - 1
      CCL = 0
      CCR = 0
      EOS = .FALSE.
      BOS = .FALSE.
      FOUND = .FALSE.
      ERROR = .FALSE.
      QUOTED = .FALSE.
      GO TO 20001
C
      END
