      LOGICAL FUNCTION  PARENS (S,F,L,NL,NR)
C     (PARENS)
C     Locates ends of parenthetical expression in string.  Quoted
C     substrings are ignored.
C
C     Arguments:
C       S = string being searched,
C       F = index of first byte to be tested,
C       L = index of last byte to be tested,
C       NL = index of left-end, '(', byte,
C       NR = index of right-end, ')', byte.
C     PARENS = .TRUE. only if expression is found without error and
C              is not preceeded by non-blank characters.
C
C     EWM  update 771109:  by JAF, added 'DATA BLANK/ 1H /'
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                BYTE,        ERROR,       LEVEL,       N
C     SETS                NL,          NR,          QUOTED
C
      INTEGER             BYTE,        F,           L,           LEVEL
      INTEGER             N,           NL,          NR,          S(1)
      LOGICAL             ERROR,       QUOTED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C
      LEVEL=0
      N=F
      PARENS=.FALSE.
      ERROR=.FALSE.
      QUOTED=.FALSE.
      GO TO 20002
20001 IF (ERROR .OR. PARENS .OR. N.GT.L) GO TO 20003
20002 BYTE = CHGET3(S,N)
      IF (.NOT.(BYTE.EQ.QUOTRZ)) GO TO 20004
      QUOTED=.NOT.QUOTED
      GO TO 20005
20004 IF (.NOT.(.NOT.(QUOTED .OR. BYTE.EQ.BLNKRZ))) GO TO 20007
      IF (.NOT.(BYTE.EQ.LEFTRZ)) GO TO 20010
      LEVEL=LEVEL+1
      IF (LEVEL.EQ.1)  NL=N
      GO TO 20011
20010 IF (.NOT.(BYTE.EQ.RITERZ)) GO TO 20013
      IF (.NOT.(LEVEL.EQ.1)) GO TO 20016
      NR=N
      PARENS=.TRUE.
      GO TO 20017
20016 LEVEL=LEVEL-1
      ERROR=LEVEL.LT.0
20017 CONTINUE
20018 GO TO 20014
20013 ERROR=LEVEL.EQ.0
20014 CONTINUE
20015 CONTINUE
20011 CONTINUE
20012 CONTINUE
20007 CONTINUE
20008 CONTINUE
20005 CONTINUE
20006 N=N+1
      GO TO 20001
C
20003 RETURN
      END
