      SUBROUTINE  REMOVE (TEXT,LENTXT,CCL,CCR,WORK)
C     (Remove Embedded Blanks)
C     Remove all blanks embedded in alphanumeric tokens lying  in
C     the substring  of  TEXT(*) delimited  by  column  positions
C     (CCL,CCR)  inclusive.   WORK(*)   must  be   an  array   of
C     sufficient size to contain all  of TEXT(*).  If any  blanks
C     are squeezed out, LENTXT will be reduced on return, and CCR
C     will be reduced to point to the same character as on entry.
C     Blanks not embedded in tokens are left intact.   Similarly,
C     blanks inside quoted strings are preserved.
C     (14-AUG-82)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3,      F4MVC,       MOD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MOD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             DECDIG,      LETTER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                ACHAR,       CCLAST,      CCNOW,       CCR
C     SETS                CCWORK,      EOS,         ERROR,       FOUND
C     SETS                LENGTH,      LENTXT,      NUL,         QCOUNT
C
      INTEGER             ACHAR,       CCL,         CCLAST,      CCNOW
      INTEGER             CCR,         CCWORK,      IARG,        LENGTH
      INTEGER             LENTXT,      NUL,         QCOUNT,      TEXT(1)
      INTEGER             WORK(1)
      LOGICAL             EOS,         ERROR,       FOUND
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C
      DATA                NUL       / -1 /
C
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a decimal digit.
C
      DECDIG(IARG) = (ZERORZ .LE. IARG) .AND. (IARG .LE. NINERZ)
C
C     LOGICAL statement function returning .TRUE. if right-zero
C     character argument is a letter.
C
      LETTER(IARG) = (ARZ .LE. IARG) .AND. (IARG .LE. ZRZ)
C
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 IF (.NOT.(.NOT.ERROR)) GO TO 20002
      ASSIGN 20005 TO NPR002
      GO TO 30002
20005 ASSIGN 20006 TO NPR003
      GO TO 30003
20006 ASSIGN 20007 TO NPR004
      GO TO 30004
20007 IF (.NOT.(FOUND)) GO TO 20008
      ASSIGN 20011 TO NPR005
      GO TO 30005
20011 ASSIGN 20012 TO NPR006
      GO TO 30006
20012 CONTINUE
20008 CONTINUE
20009 CONTINUE
20002 CONTINUE
20003 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check Parameters For Errors)
30001 ERROR = (CCL .LE. 0) .OR. (CCL .GT. CCR)
      ERROR = ERROR .OR. (CCR .LE. 0) .OR. (CCR .GT. LENTXT)
      ERROR = ERROR .OR. (LENTXT .LE. 0)
      GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Copy Current Character Into Work Area)
30007 CALL F4MVC (TEXT,CCNOW,WORK,CCWORK+1,1)
      CCWORK = CCWORK + 1
      GO TO 20022
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Copy Intervening Characters)
30008 IF (.NOT.(EOS)) GO TO 20013
      LENGTH = CCR - CCLAST - 1
      GO TO 20014
20013 LENGTH = CCNOW - CCLAST - 1
20014 IF (.NOT.(LENGTH .GT. 0)) GO TO 20016
      CALL F4MVC (TEXT,CCLAST+1,WORK,CCWORK+1,LENGTH)
      CCWORK = CCWORK + LENGTH
20016 GO TO NPR008, (20030,20031)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Copy Substring With Removal Of Embedded Blanks)
30004 ASSIGN 20019 TO NPR009
      GO TO 30009
20019 CONTINUE
20020 IF (.NOT.(.NOT.EOS)) GO TO 20021
      ASSIGN 20022 TO NPR007
      GO TO 30007
20022 IF (.NOT.(LETTER(ACHAR) .OR. DECDIG(ACHAR))) GO TO 20023
      ASSIGN 20026 TO NPR010
      GO TO 30010
20026 IF (.NOT.(.NOT.(LETTER(ACHAR) .OR. DECDIG(ACHAR)))) GO TO 20027
      ASSIGN 20030 TO NPR008
      GO TO 30008
20030 GO TO 20028
20027 IF (.NOT.(MOD(QCOUNT,2) .NE. 0)) GO TO 10001
      ASSIGN 20031 TO NPR008
      GO TO 30008
20031 GO TO 20028
10001 FOUND = .TRUE.
20028 CONTINUE
20029 GO TO 20024
20023 ASSIGN 20032 TO NPR009
      GO TO 30009
20032 CONTINUE
20024 CONTINUE
20025 GO TO 20020
20021 GO TO 20007
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Copy Text Following Substring Into Work Area)
30005 LENGTH = LENTXT - CCR
      IF (.NOT.(LENGTH .GT. 0)) GO TO 20033
      CALL F4MVC (TEXT,CCR+1,WORK,CCWORK+1,LENGTH)
      CCWORK = CCWORK + LENGTH
20033 GO TO 20011
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Copy Text Preceding Substring Into Work Area)
30003 CCWORK = CCL - 1
      IF (CCWORK .GT. 0) CALL F4MVC (TEXT,1,WORK,1,CCWORK)
      GO TO 20006
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Copy Work Area Back Into Original Text)
30006 CALL F4MVC (WORK,1,TEXT,1,CCWORK)
      CCR = CCR - (LENTXT - CCWORK)
      LENTXT = CCWORK
      GO TO 20012
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Get Next Character From Text Substring)
30009 CCNOW = CCNOW + 1
      IF (.NOT.(CCNOW .LE. CCR)) GO TO 20036
      EOS = .FALSE.
      ACHAR = CHGET3(TEXT,CCNOW)
      IF (ACHAR .EQ. QUOTRZ) QCOUNT = QCOUNT + 1
      GO TO 20037
20036 EOS = .TRUE.
      ACHAR = NUL
20037 GO TO NPR009, (20019,20032,20039,20042)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize Copy)
30002 FOUND = .FALSE.
      CCNOW = CCL - 1
      QCOUNT = 0
      GO TO 20005
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Peek Ahead To Next Non-Blank Character)
30010 CCLAST = CCNOW
      ASSIGN 20039 TO NPR009
      GO TO 30009
20039 CONTINUE
20040 IF (.NOT.((ACHAR .EQ. BLNKRZ) .AND. .NOT.EOS)) GO TO 20041
      ASSIGN 20042 TO NPR009
      GO TO 30009
20042 GO TO 20040
20041 GO TO 20026
C
      END
